com.microfocus.awm.meta.modelextension

## Class FunctionPackageExtension

- java.lang.Object
- - com.microfocus.awm.meta.modelextension.ModelExtensionObject
  - - com.microfocus.awm.meta.modelextension.ModelExtensionWithAttributes
    - - com.microfocus.awm.meta.modelextension.FunctionPackageExtension

- All Implemented Interfaces:
    IModelExtensionWithAttributes
  Direct Known Subclasses:
    DeprecatedFunctionPackage

      public class FunctionPackageExtension
      extends ModelExtensionWithAttributes

  Definition of a function package created from an extension of the AWM model extension point.

  Copyright Micro Focus GmbH.

  Author:
    Ralf Pakosch

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `FunctionPackageExtension(java.lang.String pId, java.lang.String pLabel)` Basic constructor.
    `FunctionPackageExtension(java.lang.String pId, java.lang.String pLabel, java.lang.Object pFunctionPackageInitializer)` Constructor for function packages with an initializer.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.List<? extends SimpleModelExtensionAttribute>` | `getAllAttributes()` Gets a list of all model extension attributes.
    `java.util.List<FileDescriptorExtension>` | `getFileDescriptors()` Gets `FileDescriptorExtension`s of the function package
    `FunctionPackageExtension` | `getFunctionPackageExtension()` Gets the function package extension of this feature.
    `java.util.List<IconExtension>` | `getIcons()` Gets the list of icons defined under this function package.
    `java.util.List<IDDefinitionExtension>` | `getIDDefinitions()` Gets `IDDefinitionExtension`s of the function package
    `java.lang.Object` | `getInitializer()` Gets the function package initializer, if there is one.
    `java.util.List<LinkedElementTypeExtension>` | `getLinkedElementTypes()` Gets the list of linked element types of this function package.
    `java.util.List<ModelPropertyExtension>` | `getModelProperties()` Gets `ModelPropertyExtension`s of the function package.
    `java.util.List<FunctionPackageParameter>` | `getPackageParameters()` Gets the list of package parameters.
    `java.util.List<PropertyProviderExtension>` | `getPropertyProviders()` Gets the property provider extensions of this package.
    `java.util.List<TemplateModelExtension>` | `getTemplateModels()` Gets `TemplateModelExtension`s of the function package.
    `java.util.List<ToolTypeExtension>` | `getToolTypes()` Gets the list of tool types defined by this package.
    `boolean` | `isDisabled()` Returns whether this function package extension is disabled.
    `void` | `setDisabled(boolean disabled)` Sets whether this function package extension is disabled.
    `void` | `setInitializer(java.lang.Object pInitializer)` Sets the function package initializer of this function package extension.
    `void` | `setLabel(java.lang.String pNewLabel)` Sets the label of the function package extension.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class com.microfocus.awm.meta.modelextension.ModelExtensionWithAttributes

      `getAllSimpleAttribues, getAttributes, getComplexAttributeReferences, getComplexAttributes, getReferenceAttributes`

    - ### Methods inherited from class com.microfocus.awm.meta.modelextension.ModelExtensionObject

      `getHelpContextId, getID, getLabel, isDeprecated, setDeprecated, setHelpContextId`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FunctionPackageExtension

          public FunctionPackageExtension(java.lang.String pId,
                                          java.lang.String pLabel)

      Basic constructor.
      Parameters:
        `pId` - the function package ID
        `pLabel` - the label of the function package

    - #### FunctionPackageExtension

          public FunctionPackageExtension(java.lang.String pId,
                                          java.lang.String pLabel,
                                          java.lang.Object pFunctionPackageInitializer)

      Constructor for function packages with an initializer.
      Parameters:
        `pId` - the function package ID
        `pLabel` - the label of the function package
        `pFunctionPackageInitializer` - the initializer

  - ### Method Detail

    - #### getToolTypes

          public java.util.List<ToolTypeExtension> getToolTypes()

      Gets the list of tool types defined by this package.
      Returns:
        the tool types

    - #### getPackageParameters

          public java.util.List<FunctionPackageParameter> getPackageParameters()

      Gets the list of package parameters.
      Returns:
        the package parameters

    - #### getAllAttributes

          public java.util.List<? extends SimpleModelExtensionAttribute> getAllAttributes()

      Description copied from interface: `IModelExtensionWithAttributes`
      Gets a list of all model extension attributes.
      Specified by:
        `getAllAttributes` in interface `IModelExtensionWithAttributes`
      Overrides:
        `getAllAttributes` in class `ModelExtensionWithAttributes`
      Returns:
        the list of attributes (can be empty but must not be `null`)

    - #### getPropertyProviders

          public java.util.List<PropertyProviderExtension> getPropertyProviders()

      Gets the property provider extensions of this package.
      Returns:
        the list of property provider extensions (can be empty)

    - #### getFunctionPackageExtension

          public FunctionPackageExtension getFunctionPackageExtension()

      Description copied from class: `ModelExtensionObject`
      Gets the function package extension of this feature.
      Overrides:
        `getFunctionPackageExtension` in class `ModelExtensionObject`
      Returns:
        the function package extension

    - #### getLinkedElementTypes

          public java.util.List<LinkedElementTypeExtension> getLinkedElementTypes()

      Gets the list of linked element types of this function package.
      Returns:
        the list of linked element type extensions. Can be `null`

    - #### getInitializer

          public java.lang.Object getInitializer()

      Gets the function package initializer, if there is one.
      Returns:
        the function package initializer or `null`

    - #### setInitializer

          public void setInitializer(java.lang.Object pInitializer)

      Sets the function package initializer of this function package extension.
      Parameters:
        `pInitializer` - the initializer to set

    - #### setLabel

          public void setLabel(java.lang.String pNewLabel)

      Sets the label of the function package extension.
      Parameters:
        `pNewLabel` - the label to set

    - #### isDisabled

          public boolean isDisabled()

      Returns whether this function package extension is disabled.
      Returns:
        whether this function package extension is disabled.

    - #### setDisabled

          public void setDisabled(boolean disabled)

      Sets whether this function package extension is disabled.
      Parameters:
        `disabled` - whether this function package extension is disabled.

    - #### getIcons

          public java.util.List<IconExtension> getIcons()

      Gets the list of icons defined under this function package.
      Returns:
        a list of icon extensions (can be empty)

    - #### getModelProperties

          public java.util.List<ModelPropertyExtension> getModelProperties()

      Gets `ModelPropertyExtension`s of the function package.
      Returns:
        a list of model property extensions (can be empty)

    - #### getIDDefinitions

          public java.util.List<IDDefinitionExtension> getIDDefinitions()

      Gets `IDDefinitionExtension`s of the function package
      Returns:
        a list of ID definition extensions (can be empty)

    - #### getFileDescriptors

          public java.util.List<FileDescriptorExtension> getFileDescriptors()

      Gets `FileDescriptorExtension`s of the function package
      Returns:
        a list of file descriptor extensions (can be empty)

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `ModelExtensionObject`

    - #### getTemplateModels

          public java.util.List<TemplateModelExtension> getTemplateModels()

      Gets `TemplateModelExtension`s of the function package.
      Returns:
        a list of template model extensions (can be empty)

Copyright © 2015 Micro Focus GmbH. All rights reserved.